on DBInitPlatform
  global gDBGlobalPtr1030
  set gDBGlobalPtr1030 to EMPTY
end

on DBClosePlatform
end

on DBVersion
  return FileFlex("0")
end

on DBCopyright
  return FileFlex("999")
end

on DBOpenSession
  global gDBActive1030
  if gDBActive1030 <> "true" then
    set gDBActive1030 to "true"
    return FileFlex("1")
  else
    return "0"
  end if
end

on DBCloseSession
  global gDBActive1030
  if gDBActive1030 = "true" then
    set gDBActive1030 to EMPTY
    return FileFlex("2")
  else
    return "0"
  end if
end

on DBUse dbName, pathspec
  DBCheckActive()
  if the paramCount = 1 then
    return FileFlex("3", dbName)
  else
    return FileFlex("3", dbName, pathspec)
  end if
end

on DBDatabaseExists dbName, pathspec
  DBCheckActive()
  if the paramCount = 1 then
    return FileFlex("43", dbName)
  else
    return FileFlex("43", dbName, pathspec)
  end if
end

on DBClose dbID
  DBCheckActive()
  return FileFlex("4", string(dbID))
end

on DBSelect dbID
  DBCheckActive()
  return FileFlex("5", string(dbID))
end

on DBCloseAll
  DBCheckActive()
  return FileFlex("6")
end

on DBUseIndex indexName, pathspec
  DBCheckActive()
  if the paramCount = 1 then
    return FileFlex("7", indexName)
  else
    return FileFlex("7", indexName, pathspec)
  end if
end

on DBCloseIndex indexID
  DBCheckActive()
  return FileFlex("8", string(indexID))
end

on DBSelectIndex indexID
  DBCheckActive()
  return FileFlex("9", string(indexID))
end

on DBGo recnum
  DBCheckActive()
  return FileFlex("10", string(recnum))
end

on DBTop
  DBCheckActive()
  return FileFlex("11")
end

on DBBottom
  DBCheckActive()
  return FileFlex("12")
end

on DBSeek seekExpr
  DBCheckActive()
  return FileFlex("13", seekExpr)
end

on DBSkip num
  DBCheckActive()
  return FileFlex("14", string(num))
end

on DBDeleteRecs startRec, endRec
  DBCheckActive()
  return FileFlex("15", string(startRec), string(endRec))
end

on DBRecallRecs startRec, endRec
  DBCheckActive()
  return FileFlex("16", string(startRec), string(endRec))
end

on DBZapRecs startRec, endRec
  DBCheckActive()
  return FileFlex("17", string(startRec), string(endRec))
end

on DBPack
  DBCheckActive()
  return FileFlex("18")
end

on DBCount
  DBCheckActive()
  return FileFlex("19")
end

on DBRecordDeleted recnum
  DBCheckActive()
  return FileFlex("20", string(recnum))
end

on DBCurrRecNum
  DBCheckActive()
  return FileFlex("21")
end

on DBSum numFieldName
  DBCheckActive()
  return FileFlex("22", numFieldName)
end

on DBAverage numFieldName
  DBCheckActive()
  return FileFlex("22", numFieldName) / FileFlex("19")
end

on DBGetMemo memoField, encryptFlag, key
  DBCheckActive()
  if the paramCount = 1 then
    return FileFlex("24", memoField)
  else
    return FileFlex("24", memoField, encryptFlag, key)
  end if
end

on DBWriteMemo memoField, memoVal, encryptFlag, key
  DBCheckActive()
  if the paramCount <= 2 then
    return FileFlex("25", memoField, memoVal)
  else
    return FileFlex("25", memoField, memoVal, encryptFlag, key)
  end if
end

on DBGetFieldByName fieldName, decryptFlag, key
  DBCheckActive()
  if the paramCount = 1 then
    return FileFlex("26", fieldName)
  else
    return FileFlex("26", fieldName, decryptFlag, key)
  end if
end

on DBGetFieldByNum fieldName, decryptFlag, key
  DBCheckActive()
  if the paramCount = 1 then
    return FileFlex("27", string(fieldName))
  else
    return FileFlex("27", string(fieldName), decryptFlag, key)
  end if
end

on DBGetCurrRecVal containerType, decryptList, key
  DBCheckActive()
  if the paramCount = 1 then
    return FileFlex("28", containerType)
  else
    return FileFlex("28", containerType, decryptList, key)
  end if
end

on DBListFields
  DBCheckActive()
  return FileFlex("29")
end

on DBMaxRecs
  DBCheckActive()
  return FileFlex("47")
end

on DBWriteRec containerType, recnum, p0, p1, p2
  if the paramCount = 2 then
    return FileFlex("30", containerType, string(recnum))
  else
    if the paramCount = 3 then
      return FileFlex("30", containerType, string(recnum), string(p0))
    else
      if the paramCount = 4 then
        return FileFlex("30", containerType, string(recnum), string(p0), string(p1))
      else
        return FileFlex("30", containerType, string(recnum), string(p0), string(p1), string(p2))
      end if
    end if
  end if
end

on DBCreateIndex indexName, indexExpr, unique, safety
  DBCheckActive()
  return FileFlex("31", indexName, indexExpr, string(unique), string(safety))
end

on DBReindex indexID
  DBCheckActive()
  return FileFlex("32", string(indexID))
end

on DBIndexExpr indexID
  DBCheckActive()
  return FileFlex("44", string(indexID))
end

on DBBuildSeekExpr
  DBCheckActive()
  set theFunc to "FileFlex(" & QUOTE & "45" & QUOTE
  repeat with i = 1 to the paramCount
    put "," & QUOTE & string(param(i)) & QUOTE after theFunc
  end repeat
  put ")" after theFunc
  return value(theFunc)
end

on DBListIndexFields indexID, delim
  DBCheckActive()
  return FileFlex("46", string(indexID), string(delim))
end

on DBCreate dbName, numFields, fields, safety
  DBCheckActive()
  return FileFlex("33", dbName, string(numFields), fields, string(safety))
end

on DBCheckIndex indexID
  DBCheckActive()
  return FileFlex("34", string(indexID))
end

on DBQuery expr
  DBCheckActive()
  return FileFlex("35", expr)
end

on DBLocate expr
  DBCheckActive()
  return FileFlex("35", expr)
end

on DBCurrDBNum
  DBCheckActive()
  return FileFlex("36")
end

on DBEncrypt theString, key
  DBCheckActive()
  return FileFlex("38", theString, key)
end

on DBDecrypt theString, key
  DBCheckActive()
  return FileFlex("39", theString, key)
end

on DBFindMemo memoField, theString
  DBCheckActive()
  return FileFlex("40", memoField, theString)
end

on DBConvertCRLF theString, theOption
  DBCheckActive()
  if the paramCount = 1 then
    return FileFlex("41", theString)
  else
    return FileFlex("41", theString, theOption)
  end if
end

on DBPlatform
  DBCheckActive()
  return FileFlex("42")
end

on DBTranslateChars string, table
  DBCheckActive()
  return FileFlex("48", string, table)
end

on DBSetSortOrder order
  global gDBWorldSort, gDBSortOrder
  if order = EMPTY then
    set gDBWorldSort to EMPTY
  else
    set gDBWorldSort to "1"
    set gDBSortOrder to order
  end if
  return 0
end

on DBSetCaseTables upperTable, lowerTable
  global gDBWorldCase, gDBWorldUpper, gDBWorldLower
  if (upperTable = EMPTY) or (lowerTable = EMPTY) then
    set gDBWorldCase to EMPTY
  else
    set gDBWorldCase to "1"
    set gDBWorldUpper to upperTable
    set gDBWorldLower to lowerTable
  end if
  return 0
end

on DBUpper s
  DBCheckActive()
  return FileFlex("49", string(s))
end

on DBLower s
  DBCheckActive()
  return FileFlex("50", string(s))
end

on DBCheckActive
  global gDBActive1030
  if gDBActive1030 <> "true" then
    set dummy to DBOpenSession()
  end if
end

on DBSetGlobal globName, globVal
  return FileFlex("202", string(globName), string(globVal))
end

on DBGetGlobal globName
  return FileFlex("201", string(globName))
end
